/*    macchinetta     */

#include "descriptor/descriptor.h"
#include "descriptor/textures.h"

int main(void)
{

	//superfici
	ITEM corpo;
	ITEM soprabase;
	ITEM metallo;
	ITEM pulsanti;
	ITEM tronco;
	ITEM led_acceso, led;
	ITEM ante, pomelli, mobile;
	ITEM pavimento;

	//scena
	ITEM scene;

	//attributi
	ITEM attr_mobile, attr_pomelli, attr_macch, attr_crom, attr_pulsanti, attr_tronco, attr_ante, attr_led_acceso, attr_led, attr_pavim;

	//background and ambient settings
	set_background(1, 0.90, 0.788, TRUE);
	set_ambient_light(1, 1, 1, 1);


	//light setting
	create_point_light(32.184, 24.731, 5.406,  1, 1, 1,  2,  0,  "key light");
	create_point_light(32.184, -24.731, 5.406,  1, 1, 1,  1,  0,  "fill light");
	create_point_light(-1.394, -0.976, 12.860,  1, 1, 1,  1,  0,  "back light");
	create_warn_light(0.216, 0.993, -0.238,  -0.775, -0.629, 0.044,  1, 0.33, 0,  6,  1,  0,  6,  0, 0, 0, 0, 0, "led");


	// caricamento e disposizione oggetti

	corpo=read_obj("plastica.obj", "macchinetta");
	led_acceso=read_obj("led_acceso.obj", "led_acceso");
	led=read_obj("led.obj", "led");
	pulsanti=read_obj("pulsanti.obj", "pulsanti");
	metallo=read_obj("metallo.obj", "metallo");
	tronco=read_nurbs("cap2.db");
	soprabase=read_obj("soprabase.obj", "soprabase");

	mobile=read_obj("struttura.obj", "mobile");
	set_scale_abs(mobile, 1.5, 1.5, 1.2);
	set_translate(mobile, 0.0, 0.32, 0.381);

	ante=read_obj("vetri.obj", "ante");
	set_scale_abs(ante, 1.5, 1.5, 1.2);
	set_translate(ante, 0.0, 0.32, 0.381);

	pomelli=read_obj("pomelli.obj", "pomelli");
	set_scale_abs(pomelli, 1.5, 1.5, 1.2);
	set_translate(pomelli, 0.0, 0.32, 0.381);

	pavimento=read_nurbs("pavimento.db");
	set_scale_abs(pavimento, 3, 3, 1.2);
	set_translate(pavimento, 0.0, 0.32, 0.381);


	//creazione e link degli attributi

	attr_mobile=create_attribute("attr_mobile");
	set_color(attr_mobile, 0.58, 0.14, 0, 0.3, 0.262);
	set_reflectivity(attr_mobile, 0.180, 15);
	set_transparency(attr_mobile, 0, 0, 0, 0.6);

	set_attribute(mobile, attr_mobile);

	attr_pomelli=create_attribute("attr_pomelli");
	set_color(attr_pomelli, 1, 0.86, 0, 0.1, 0.3);
	set_reflectivity(attr_pomelli, 0.4, 5);
	set_transparency(attr_pomelli, 0, 0, 0, 1);

	set_attribute(pomelli, attr_pomelli);

	attr_macch=create_attribute("attr_macch");
	set_color(attr_macch, 1, 0.98, 0.86, 0.2, 0.25);
	set_reflectivity(attr_macch, 0.03, 1);
	set_transparency(attr_macch, 0, 0, 0, 1.7);

	set_attribute(corpo, attr_macch);

	attr_crom=create_attribute("attr_crom");
	set_color(attr_crom, 0.79, 0.79, 0.84, 0, 0.5);
	set_reflectivity(attr_crom, 0.2, 2);
	set_transparency(attr_crom, 0, 0, 0, 1.6);

	set_attribute(metallo, attr_crom);

	attr_pulsanti=create_attribute("attr_pulsanti");
	set_color(attr_pulsanti, 0.427, 0.427, 0.427, 0.2, 0.25);
	set_reflectivity(attr_pulsanti, 0.03, 1);
	set_transparency(attr_pulsanti, 0, 0, 0, 1.7);

	set_attribute(pulsanti, attr_pulsanti);
	set_attribute(soprabase, attr_pulsanti);

	attr_tronco=create_attribute("attr_tronco");
	set_color(attr_tronco, 0, 0, 0, 0.2, 0.25);
	set_reflectivity(attr_tronco, 0.03, 1);
	set_transparency(attr_tronco, 0, 0, 0, 1.7);

	set_attribute(tronco, attr_tronco);

	attr_led_acceso=create_attribute("attr_led_acceso");
	set_color(attr_led_acceso,  1, 1, 1,  0, 0);
	set_reflectivity(attr_led_acceso, 0, 0);
	set_transparency(attr_led_acceso, 0.45, 0.2, 5, 1.2);

	set_attribute(led_acceso, attr_led_acceso);

	attr_led=create_attribute("attr_led");
	set_color(attr_led,  0.77, 1, 1,  0.1, 0.134);
	set_reflectivity(attr_led, 0.1, 2);
	set_transparency(attr_led, 0.45, 0.2, 5, 1.2);

	set_attribute(led, attr_led);


	attr_pavim=create_attribute("attr_pavim");
	set_color(attr_pavim, 0.87, 0.756, 0.654, 0.67, 0.229);
	set_reflectivity(attr_pavim, 0.2, 5);
	set_transparency(attr_pavim, 0, 0, 0, 1);

	//texture pavimento

	set_domain_texture(pavimento, attr_pavim, "textures/pavim0028.hr", 0, 0.05, 0, 0.05, 1, 0.2, 0.2);

	attr_ante=create_attribute("attr_ante");
	set_color(attr_ante, 0.68, 0.86, 1, 0.1, 0.1);
	set_reflectivity(attr_ante, 0.24, 2);
	set_transparency(attr_ante, 0.9, 0.9, 1, 1.2);

	set_attribute(ante, attr_ante);

	scene=create_list(corpo, "scene");
	scene=insert_in_list(scene, tronco);
	scene=insert_in_list(scene, metallo);
	scene=insert_in_list(scene, pulsanti);
	scene=insert_in_list(scene, led);
	scene=insert_in_list(scene, led_acceso);
	scene=insert_in_list(scene, soprabase);
	scene=insert_in_list(scene, mobile);
	scene=insert_in_list(scene, ante);
	scene=insert_in_list(scene, pomelli);
	scene=insert_in_list(scene, pavimento);
	save_scene("espresso.md", "espresso", scene);
	return(0);
}

